<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Merriweather&display=swap" rel="stylesheet">
    <link href="https://fonts.googleapis.com/css2?family=Poppins&display=swap" rel="stylesheet">
    <title>List of Users</title>
    <link rel="stylesheet" href="style.css">
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        // danh sách users (mảng các đối tượng users)
        var gListUsers = [
            {
                userCode: "100-lelah",
                userFullName: "Lelah Nichols",
                userAddress: "Troy, MI",
                userAvatar: "images/users/lelah_nichols.png",
                userHobbies: ["clothes", "stem"]
            },
            {
                userCode: "110-jesus",
                userFullName: "Jesus Weiss",
                userAddress: "Fort Worth, TX",
                userAvatar: "images/users/jesus_weiss.png",
                userHobbies: ["headset", "gadget", "speed", "winter"]
            },
            {
                userCode: "120-annie",
                userFullName: "Annie Rice",
                userAddress: "Austin, TX",
                userAvatar: "images/users/annie_rice.png",
                userHobbies: ["road", "mountain", "trip", "earth", "nature"]
            },
            {
                userCode: "130-robert",
                userFullName: "Robert Brower",
                userAddress: "Cincinnati, OH",
                userAvatar: "images/users/robert_brower.png",
                userHobbies: ["Maintenance", "gears", "frames", "repair"]
            },
            {
                userCode: "140-amy",
                userFullName: "Amy Campbell",
                userAddress: "Warrior, AL",
                userAvatar: "images/users/amy_campbell.png",
                userHobbies: ["music", "disks"]
            },
            {
                userCode: "150-anthony",
                userFullName: "Anthony S. Morin",
                userAddress: "Lyndhurst, NJ",
                userAvatar: "images/users/anthony_smorin.png",
                userHobbies: ["vintage", "electric"]
            }
        ];
         

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            loadUsers();
        }
        function onBtnFilterUser() {
            var vUserFound = null;
            var vUserCodeFound = null;
            var vSearchInput = document.getElementById("inp-search");
            var vSearchUserFullName = vSearchInput.value.trim(); //Lấy giá trị nhập vào

            if (vSearchUserFullName == "") { //Cảnh báo nếu chưa nhập
                alert("Bạn chưa nhập username can tim");
            }
            else { //Nhập rồi mới tìm
                vUserFound = getUserByUserName(vSearchUserFullName);
                vUserCodeFound = getUserByUserCode(vSearchUserFullName);
                var vDivListUser = document.getElementById("infor_content");
                vDivListUser.innerHTML = "";
                if (vUserFound != null)  { //Tìm thấy
                    vDivListUser.innerHTML += `
                    <div class="infor">
                            <div class="avatar">
                                <img src="${vUserFound.userAvatar}" alt="">
                            </div>
                            <div class="avatar_infor">
                                <div class="name">${vUserFound.userFullName}</div>
                                <div class="address">${vUserFound.userAddress}</div>
                                <div class="hobbies">
                                    <div class="like">${vUserFound.userHobbies}</div>    
                                </div>
                            </div>
                        </div>
                    `;
                }
                if (vUserCodeFound != null)  { //Tìm thấy
                    vDivListUser.innerHTML += `
                    <div class="infor">
                            <div class="avatar">
                                <img src="${vUserCodeFound.userAvatar}" alt="">
                            </div>
                            <div class="avatar_infor">
                                <div class="name">${vUserCodeFound.userFullName}</div>
                                <div class="address">${vUserCodeFound.userAddress}</div>
                                <div class="hobbies">
                                    <div class="like">${vUserCodeFound.userHobbies}</div>    
                                </div>
                            </div>
                        </div>
                    `;
                }
                else { //Không tìm thấy
                    alert("Không có user trùng với user này")
                }
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        function loadUsers () {
                var vDivFootContent = document.getElementById("infor_content");
                vDivFootContent.innerHTML = "";
                for (var bIndex = 0; bIndex <gListUsers.length; bIndex++) 
                {
                    console.log(gListUsers[bIndex]);
                    vDivFootContent.innerHTML += `
                        <div class="infor">
                            <div class="avatar">
                                <img src="${gListUsers[bIndex].userAvatar}" alt="">
                            </div>
                            <div class="avatar_infor">
                                <div class="name">${gListUsers[bIndex].userFullName}</div>
                                <div class="address">${gListUsers[bIndex].userAddress}</div>
                                <div class="hobbies" id="hobbies-${bIndex}"></div>
                            </div>
                        </div>
                    `; 
                    var vDivHobbies = document.getElementById(`hobbies-${bIndex}`); 
                    vDivHobbies.innerHTML = "";
                    for(var jIndex = 0; jIndex <gListUsers[bIndex].userHobbies.length; jIndex++) 
                    {
                        vDivHobbies.innerHTML += `<div class="like">${gListUsers[bIndex].userHobbies[jIndex]}</div>`;
                    }
                }            
        }

        //Hàm tìm kiếm đối tượng user theo userfullname
        function getUserByUserName(paramUserFullName) {
            var vUserInforObj = null; //Đối tượng userInfor
            var vUserInforIndex = 0; //Vị trí thứ 0
            var vUserFound = false; //Có tìm thấy user cần tìm hay không 
            while (vUserFound == false && vUserInforIndex < gListUsers.length) {    //Trong khi chưa tìm thấy user và vị trí vẫn còn trong mảng đối tượng
                if (gListUsers[vUserInforIndex].userFullName == paramUserFullName) {  //Nếu có userfullname trùng
                    vUserInforObj = gListUsers[vUserInforIndex];   //Lưu đối tượng vào
                    vUserFound = true;    //Đã tìm thấy
                }
                else {  //Nếu không tìm thấy thì tăng vị trí lên 1
                    vUserInforIndex++;
                }
            }
            return vUserInforObj; //Trả về đối tượng
        }

        //Ham tim kiem doi tuong user theo usercode
        function getUserByUserCode(paramUserCode) {
            var vUserInforObj = null; //Đối tượng userInfor
            var vUserInforIndex = 0; //Vị trí thứ 0
            var vUserFound = false; //Có tìm thấy user cần tìm hay không 
            while (vUserFound == false && vUserInforIndex < gListUsers.length) {    //Trong khi chưa tìm thấy user và vị trí vẫn còn trong mảng đối tượng
                if (gListUsers[vUserInforIndex].userCode == paramUserCode) {  //Nếu có userfullname trùng
                    vUserInforObj = gListUsers[vUserInforIndex];   //Lưu đối tượng vào
                    vUserFound = true;    //Đã tìm thấy
                }
                else {  //Nếu không tìm thấy thì tăng vị trí lên 1
                    vUserInforIndex++;
                }
            }
            return vUserInforObj; //Trả về đối tượng
        }

    </script>    
</head>

<body onload="onPageLoading()">
    <div class="container">
        <div class="header">
            <h1>List of users</h1>
        </div>
        <div class="content">
            <div class="left-content">
                <form class="nosubmit">
                    <input class="nosubmit" id="inp-search" type="search" placeholder="Search users...">
                </form>
                <button class="btn-search" id="btn-filter-user" onclick="onBtnFilterUser()">Filter Users</button>
            </div>
            <div class="right-content">
                <ul>
                    <li><a href="#home">New Users</a></li>
                    <li><a href="#news">Voters</a></li>
                    <li><a href="#contact">Editors</a></li>
                    <li><a href="#about">Modertors</a></li>
                  </ul>
            </div>
        </div>

        <div class="infor-content" id="infor_content">
            <div class="infor">
                <div class="avatar">
                    <img src="images/users/lelah_nichols.png" alt="Lelah">
                </div>
                <div class="avatar_infor">
                    <div class="name">Lelah Nichols</div>
                    <div class="address">Troy, MI</div>
                    <div class="hobbies">
                        <div class="like">clothes</div>
                        <div class="like">stem</div>
                    </div>
                </div>
            </div>

            <div class="infor">
                <div class="avatar">
                    <img src="images/users/jesus_weiss.png" alt="Jesus">
                </div>
                <div class="avatar_infor">
                    <div class="name">Jesus Weiss</div>
                    <div class="address">Forth Worth, TX</div>
                    <div class="hobbies">
                        <div class="like">headset</div>
                        <div class="like">gadget</div>
                    </div>
                </div>
            </div>

            <div class="infor">
                <div class="avatar">
                    <img src="images/users/annie_rice.png" alt="annie">
                </div>
                <div class="avatar_infor">
                    <div class="name">Annie Rice</div>
                    <div class="address">Austin, TX</div>
                    <div class="hobbies">
                        <div class="like">road</div>
                        <div class="like">mountain</div>
                        <div class="like">trip</div>
                        <div class="like">earth</div>
                        <div class="like">nature</div>
                    </div>
                </div>
            </div>

            <div class="infor">
                <div class="avatar">
                    <img src="images/users/robert_brower.png" alt="robert">
                </div>
                <div class="avatar_infor">
                    <div class="name">Robert Brower</div>
                    <div class="address">Cinici, OH</div>
                    <div class="hobbies">
                        <div class="like">Maintainece</div>
                        <div class="like">gear</div>
                        <div class="like">frame</div>
                        <div class="like">repair</div>
                    </div>
                </div>
            </div>

            <div class="infor">
                <div class="avatar">
                    <img src="images/users/amy_campbell.png" alt="amy">
                </div>
                <div class="avatar_infor">
                    <div class="name">Amy Campel</div>
                    <div class="address">Warrior,AL</div>
                    <div class="hobbies">
                        <div class="like">music</div>
                        <div class="like">disk</div>
                    </div>
                </div>
            </div>

            <div class="infor">
                <div class="avatar">
                    <img src="images/users/anthony_smorin.png" alt="Anthony">
                </div>
                <div class="avatar_infor">
                    <div class="name">Anthony S Morin</div>
                    <div class="address">LynHurst, NY</div>
                    <div class="hobbies">
                        <div class="like">vintage</div>
                        <div class="like">electrics</div>
                    </div>
                </div>
            </div>
            
        </div>
    </div>
</body>

</html>